#!/usr/bin/perl

# -- HEADER
print "Content-Type: text/html\n\n";

# -- Get name and subject
$input = <STDIN>;

$input =~ s/\n//;
$message = $action = $MID = $subject = $name = $input;

$name =~ s/^.*name=//;
$name =~ s/&.*$//;
$name =~ s/\+/ /g;
$name =~ s/%0D%0A/<br>/g;
$name =~ s/%([0-9A-F][0-9A-F])/chr(hex($1))/eg;

$subject =~ s/^.*subject=//;
$subject =~ s/&.*$//;
$subject =~ s/\+/ /g;
$subject =~ s/%0D%0A/<br>/g;
$subject =~ s/%([0-9A-F][0-9A-F])/chr(hex($1))/eg;

$MID =~ s/^.*messageID=//;
$MID =~ s/&.*$//;

$action =~ s/^.*action=//;
$action =~ s/&.*$//;

$message =~ s/^.*message=//;
$message =~ s/&.*$//;
$message =~ s/\+/ /g;
$message =~ s/%0D%0A/<br>/g;
$message =~ s/%([0-9A-F][0-9A-F])/chr(hex($1))/eg;

# -- Only user admin has admin-rights
if ($name eq "admin")
{
	$admin = 1;
}
else
{
	$admin = 0;
}

# -- Special user guest
if ($name eq "guest")
{
	$guest = 1;
}
else
{
	$guest = 0;
}

# -- Sub-function to write or NOT write $line
sub write_line
{
	if ($line =~ m/#ADMIN_BEGIN/)
	{
		$write = $admin;
	}
	elsif ($line =~ m/#ADMIN_END/)
	{
		$write = 1;
	}
	elsif ($line =~ m/#GUEST_BEGIN/)
	{
		$write = $guest;
	}
	elsif ($line =~ m/#GUEST_END/)
	{
		$write = 1;
	}
	elsif ($line =~ m/#NORMAL_BEGIN/)
	{
		$write = 1 - $guest;	# normal users are all users other theb guests
	}
	elsif ($line =~ m/#NORMAL_END/)
	{
		$write = 1;
	}
	elsif ($write == 1)
	{
		print $line;
	}
}

# -- Do action ADD
if ($action eq "add")
{
	open TEMP, ">temp.dat";
	open FORUM, "<forum.dat";
	$oldID = <FORUM>;
	print TEMP $oldID;

	while (<FORUM>)
	{
		print TEMP $_;
	}

	close FORUM;
	close TEMP;

	open TEMP, "<temp.dat";
	open FORUM, ">forum.dat";

	print FORUM $oldID+1;
	print FORUM "\n$subject\n";
	print FORUM "$name\n";
	print FORUM time;
	print FORUM "\n$message\n";

	while (<TEMP>)
	{
		print FORUM $_;
	}

	close TEMP;
	close FORUM;
}

# -- Do action DELETE
if ($action eq "delete")
{
	open FORUM, "<forum.dat";
	open TEMP, ">temp.dat";

	while (<FORUM>)
	{
		$id = $_;
		$id =~ s/\n//;
		$s = <FORUM>;
		$n = <FORUM>;
		$t = <FORUM>;
		$m = <FORUM>;

		if ($id ne $MID)
		{
			print TEMP "$id\n";
			print TEMP $s;
			print TEMP $n;
			print TEMP $t;
			print TEMP $m;
		}
	}
	
	close FORUM;
	close TEMP;

	open FORUM, ">forum.dat";
	open TEMP, "<temp.dat";

	while (<TEMP>)
	{
		print FORUM $_;
	}

	close TEMP;
	close FORUM;
}

# -- count the number of messages in this subject
open FORUM, "<forum.dat";
while (<FORUM>)
{
	$s = <FORUM>;
	$s =~ s/\n//;
	<FORUM>;
	<FORUM>;
	<FORUM>;

	if ($subject eq $s)
	{
	    $nomessages++;
	}
}
close FORUM;

# -- Write the top of the page
open PAGE, "<forum.html";
$line = "";
$write = 1;

for (; !($line =~ m/#MESSAGE_BEGIN/); $line = <PAGE>)
{
	$line =~ s/#NAME/$name/;
	$line =~ s/#SUBJECT/$subject/;
	$line =~ s/#NUMBER_OF_MESSAGES/$nomessages/;

	write_line;
}
close PAGE;

# -- For every message write the message-HTML
open FORUM, "<forum.dat";

while (<FORUM>)
{
	$id = $_;
	$id =~ s/\n//;
	$s = <FORUM>;
	$s =~ s/\n//;
	$n = <FORUM>;
	$n =~ s/\n//;
	$t = <FORUM>;
	$t =~ s/\n//;
	$m = <FORUM>;
	$m =~ s/\n//;

	if ($subject eq $s)
	{
		open PAGE, "<forum.html";
		$line = "";
		for (; !($line =~ m/#MESSAGE_BEGIN/); $line = <PAGE>) {}
		$line = <PAGE>;
		for (; !($line =~ m/#MESSAGE_END/); $line = <PAGE>) 
		{
			$line =~ s/#NAAM/$naam/;
			$line =~ s/#SUBJECT/$subject/;
			$line =~ s/#MESSAGE_ID/$id/;
			$line =~ s/#MESSAGE/$m/;
			$line =~ s/#AUTHOR/$n/;

			# -- time substitution
			@time = localtime ($t + 9*3600);
			$zero = "0$time[0]";
			$zero =~ s/^.*(..)$/$1/;
			$line =~ s/#SECONDS/$zero/;
			$zero = "0$time[1]";
			$zero =~ s/^.*(..)$/$1/;
			$line =~ s/#MINUTES/$zero/;
			$line =~ s/#HOURS/$time[2]/;

			# -- date substitution
			$line =~ s/#DAY/$time[3]/;
			$line =~ s/#MONTH/$time[4]/;
			$year = $time[5] + 1900;
			$line =~ s/#YEAR/$year/;
			$line =~ s/#DAY_OF_WEEK/$time[6]/;

			$ttime = localtime ($t + 9*3600);
			$line =~ s/#TIME/$ttime/;

			$line =~ s/#NUMBER_OF_MESSAGES/$nomessages/;

			write_line;
		}
		close PAGE;
	}
}

# -- Write the bottom part of the page
open PAGE, "<forum.html";

$line = "";
for (; !($line =~ m/#MESSAGE_END/); $line = <PAGE>) {}
while (<PAGE>)
{
	$line = $_;
	$line =~ s/#NAME/$name/;
	$line =~ s/#SUBJECT/$subject/;
	$line =~ s/#NUMBER_OF_MESSAGES/$nomessages/;

	write_line;
}

